Index: NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_write.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_write.F90	(revision 15731)
+++ NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_write.F90	(revision 15799)
@@ -54,5 +54,5 @@
 CONTAINS
 
-   SUBROUTINE obs_wri_prof( profdata, padd, pext )
+   SUBROUTINE obs_wri_prof( profdata, clfiletype, padd, pext )
       !!-----------------------------------------------------------------------
       !!
@@ -77,13 +77,20 @@
       !! * Arguments
       TYPE(obs_prof), INTENT(INOUT) :: profdata      ! Full set of profile data
-      TYPE(obswriinfo), OPTIONAL :: padd             ! Additional info for each variable
-      TYPE(obswriinfo), OPTIONAL :: pext             ! Extra info
+      CHARACTER(LEN=25), INTENT(IN) :: clfiletype    ! Base name for file name
+      TYPE(obswriinfo), OPTIONAL    :: padd          ! Additional info for each variable
+      TYPE(obswriinfo), OPTIONAL    :: pext          ! Extra info
 
       !! * Local declarations
       TYPE(obfbdata) :: fbdata
       CHARACTER(LEN=40) :: clfname
-      CHARACTER(LEN=10) :: clfiletype
+      CHARACTER(LEN=ilenlong) :: cllongname  ! Long name of variable
+      CHARACTER(LEN=ilenunit) :: clunits     ! Units of variable
+      CHARACTER(LEN=ilengrid) :: clgrid      ! Grid of variable
+      CHARACTER(LEN=12) :: clfmt            ! writing format
+      INTEGER :: idg                        ! number of digits
       INTEGER :: ilevel
       INTEGER :: jvar
+      INTEGER :: jvar2
+      INTEGER :: jsal
       INTEGER :: jo
       INTEGER :: jk
@@ -111,79 +118,41 @@
       ! Find maximum level
       ilevel = 0
-      DO jvar = 1, 2
+      DO jvar = 1, profdata%nvar
          ilevel = MAX( ilevel, MAXVAL( profdata%var(jvar)%nvlidx(:) ) )
       END DO
 
-      SELECT CASE ( TRIM(profdata%cvars(1)) )
-      CASE('POTM')
-
-         clfiletype='profb'
-         CALL alloc_obfbdata( fbdata, 2, profdata%nprof, ilevel, &
-            &                 1 + iadd, 1 + iext, .TRUE. )
-         fbdata%cname(1)      = profdata%cvars(1)
-         fbdata%cname(2)      = profdata%cvars(2)
-         fbdata%coblong(1)    = 'Potential temperature'
-         fbdata%coblong(2)    = 'Practical salinity'
-         fbdata%cobunit(1)    = 'Degrees centigrade'
-         fbdata%cobunit(2)    = 'PSU'
-         fbdata%cextname(1)   = 'TEMP'
-         fbdata%cextlong(1)   = 'Insitu temperature'
-         fbdata%cextunit(1)   = 'Degrees centigrade'
-         fbdata%caddlong(1,1) = 'Model interpolated potential temperature'
-         fbdata%caddlong(1,2) = 'Model interpolated practical salinity'
-         fbdata%caddunit(1,1) = 'Degrees centigrade'
-         fbdata%caddunit(1,2) = 'PSU'
-         fbdata%cgrid(:)      = 'T'
-         DO je = 1, iext
-            fbdata%cextname(1+je) = pext%cdname(je)
-            fbdata%cextlong(1+je) = pext%cdlong(je,1)
-            fbdata%cextunit(1+je) = pext%cdunit(je,1)
-         END DO
-         DO ja = 1, iadd
-            fbdata%caddname(1+ja) = padd%cdname(ja)
-            DO jvar = 1, 2
+      CALL alloc_obfbdata( fbdata, profdata%nvar, profdata%nprof, ilevel, &
+            &                 1 + iadd, iext, .TRUE. )
+      fbdata%caddname(1)   = 'Hx'
+      DO jvar = 1, profdata%nvar
+         fbdata%cname(jvar)      = profdata%cvars(jvar)
+         fbdata%coblong(jvar)    = profdata%clong(jvar)
+         fbdata%cobunit(jvar)    = profdata%cunit(jvar)
+         fbdata%cgrid(jvar)      = profdata%cgrid(jvar)
+         fbdata%caddlong(1,jvar) = 'Model interpolated ' // TRIM(profdata%clong(jvar))
+         fbdata%caddunit(1,jvar) = profdata%cunit(jvar)
+         IF (iadd > 0) THEN
+            DO ja = 1, iadd
+               fbdata%caddname(1+ja) = padd%cdname(ja)
                fbdata%caddlong(1+ja,jvar) = padd%cdlong(ja,jvar)
                fbdata%caddunit(1+ja,jvar) = padd%cdunit(ja,jvar)
             END DO
-         END DO
-
-      CASE('UVEL')
-
-         clfiletype='velfb'
-         CALL alloc_obfbdata( fbdata, 2, profdata%nprof, ilevel, 1, 0, .TRUE. )
-         fbdata%cname(1)      = profdata%cvars(1)
-         fbdata%cname(2)      = profdata%cvars(2)
-         fbdata%coblong(1)    = 'Zonal velocity'
-         fbdata%coblong(2)    = 'Meridional velocity'
-         fbdata%cobunit(1)    = 'm/s'
-         fbdata%cobunit(2)    = 'm/s'
-         DO je = 1, iext
-            fbdata%cextname(je) = pext%cdname(je)
-            fbdata%cextlong(je) = pext%cdlong(je,1)
-            fbdata%cextunit(je) = pext%cdunit(je,1)
-         END DO
-         fbdata%caddlong(1,1) = 'Model interpolated zonal velocity'
-         fbdata%caddlong(1,2) = 'Model interpolated meridional velocity'
-         fbdata%caddunit(1,1) = 'm/s'
-         fbdata%caddunit(1,2) = 'm/s'
-         fbdata%cgrid(1)      = 'U' 
-         fbdata%cgrid(2)      = 'V'
-         DO ja = 1, iadd
-            fbdata%caddname(1+ja) = padd%cdname(ja)
-            fbdata%caddlong(1+ja,1) = padd%cdlong(ja,1)
-            fbdata%caddunit(1+ja,1) = padd%cdunit(ja,1)
-         END DO
-
-      END SELECT
-
-      fbdata%caddname(1)   = 'Hx'
-
-      WRITE(clfname, FMT="(A,'_fdbk_',I4.4,'.nc')") TRIM(clfiletype), nproc
+         ENDIF
+         IF (iext > 0) THEN
+            DO je = 1, iext
+               fbdata%cextname(je) = pext%cdname(je)
+               fbdata%cextlong(je) = pext%cdlong(je,1)
+               fbdata%cextunit(je) = pext%cdunit(je,1)
+            END DO
+         ENDIF
+      END DO
+
+      WRITE(clfname, FMT="(A,'fb_fdbk_',I4.4,'.nc')") TRIM(clfiletype), nproc
 
       IF(lwp) THEN
          WRITE(numout,*)
-         WRITE(numout,*)'obs_wri_prof :'
-         WRITE(numout,*)'~~~~~~~~~~~~~'
-         WRITE(numout,*)'Writing '//TRIM(clfiletype)//' feedback file : ',TRIM(clfname)
+         WRITE(numout,*) 'obs_wri_prof :'
+         WRITE(numout,*) '~~~~~~~~~~~~~'
+         WRITE(numout,*) 'Writing '//TRIM(clfiletype)//' feedback file : ', TRIM(clfname)
       ENDIF
 
@@ -228,5 +197,5 @@
             &           krefdate = 19500101 )
          ! Reform the profiles arrays for output
-         DO jvar = 1, 2
+         DO jvar = 1, profdata%nvar
             DO jk = profdata%npvsta(jo,jvar), profdata%npvend(jo,jvar)
                ik = profdata%var(jvar)%nvlidx(jk)
@@ -247,38 +216,60 @@
                ENDIF
                fbdata%iobsk(ik,jo,jvar)  = profdata%var(jvar)%mvk(jk)
-               DO ja = 1, iadd
-                  fbdata%padd(ik,jo,1+ja,jvar) = &
-                     & profdata%var(jvar)%vext(jk,padd%ipoint(ja))
+               IF (iadd > 0) THEN
+                  DO ja = 1, iadd
+                     fbdata%padd(ik,jo,1+ja,jvar) = &
+                        & profdata%var(jvar)%vadd(jk,padd%ipoint(ja))
+                  END DO
+               ENDIF
+            END DO
+         END DO
+         IF (iext > 0) THEN
+            DO jk = profdata%npvstaext(jo), profdata%npvendext(jo)
+               ik = profdata%vext%nelidx(jk)
+               DO je = 1, iext
+                  fbdata%pext(ik,jo,je) = &
+                     & profdata%vext%eobs(jk,pext%ipoint(je))
                END DO
-               DO je = 1, iext
-                  fbdata%pext(ik,jo,1+je) = &
-                     & profdata%var(jvar)%vext(jk,pext%ipoint(je))
-               END DO
-               IF ( ( jvar == 1 ) .AND. &
-                  & ( TRIM(profdata%cvars(1)) == 'POTM' ) ) THEN
-                  fbdata%pext(ik,jo,1) = profdata%var(jvar)%vext(jk,1)
-               ENDIF 
-            END DO
-         END DO
+            END DO
+         ENDIF
       END DO
 
-      IF ( TRIM(profdata%cvars(1)) == 'POTM' ) THEN
-         ! Convert insitu temperature to potential temperature using the model
-         ! salinity if no potential temperature
-         DO jo = 1, fbdata%nobs
-            IF ( fbdata%pphi(jo) < 9999.0 ) THEN
-               DO jk = 1, fbdata%nlev
-                  IF ( ( fbdata%pob(jk,jo,1) >= 9999.0 ) .AND. &
-                     & ( fbdata%pdep(jk,jo) < 9999.0 ) .AND. &
-                     & ( fbdata%padd(jk,jo,1,2) < 9999.0 ) .AND. &
-                     & ( fbdata%pext(jk,jo,1) < 9999.0 ) ) THEN
-                     zpres = dep_to_p( REAL(fbdata%pdep(jk,jo),wp), &
-                        &              REAL(fbdata%pphi(jo),wp) )
-                     fbdata%pob(jk,jo,1) = potemp( &
-                        &                     REAL(fbdata%padd(jk,jo,1,2), wp),  &
-                        &                     REAL(fbdata%pext(jk,jo,1), wp), &
-                        &                     zpres, 0.0_wp )
+      ! Convert insitu temperature to potential temperature using the model
+      ! salinity if no potential temperature
+      IF (iext > 0) THEN
+         DO jvar = 1, profdata%nvar
+            IF ( TRIM(profdata%cvars(jvar)) == 'POTM' ) THEN
+               jsal = 0
+               DO jvar2 = 1, profdata%nvar
+                  IF ( TRIM(profdata%cvars(jvar2)) == 'PSAL' ) THEN
+                     jsal = jvar2
+                     EXIT
                   ENDIF
                END DO
+               IF (jsal > 0) THEN
+                  DO je = 1, iext
+                     IF ( TRIM(fbdata%cextname(je)) == 'TEMP' ) THEN
+                        DO jo = 1, fbdata%nobs
+                           IF ( fbdata%pphi(jo) < 9999.0 ) THEN
+                              DO jk = 1, fbdata%nlev
+                                 IF ( ( fbdata%pob(jk,jo,jvar)   >= 9999.0 ) .AND. &
+                                    & ( fbdata%pdep(jk,jo)        < 9999.0 ) .AND. &
+                                    & ( fbdata%padd(jk,jo,1,jsal) < 9999.0 ) .AND. &
+                                    & ( fbdata%pext(jk,jo,je)     < 9999.0 ) ) THEN
+                                    zpres = dep_to_p( REAL(fbdata%pdep(jk,jo),wp), &
+                                       &              REAL(fbdata%pphi(jo),wp) )
+                                    fbdata%pob(jk,jo,jvar) = potemp( &
+                                       &                     REAL(fbdata%padd(jk,jo,1,jsal), wp), &
+                                       &                     REAL(fbdata%pext(jk,jo,je), wp),     &
+                                       &                     zpres, 0.0_wp )
+                                 ENDIF
+                              END DO
+                           ENDIF
+                        END DO
+                        EXIT
+                     ENDIF
+                  END DO
+               ENDIF
+               EXIT
             ENDIF
          END DO
@@ -295,5 +286,5 @@
    END SUBROUTINE obs_wri_prof
 
-   SUBROUTINE obs_wri_surf( surfdata, padd, pext )
+   SUBROUTINE obs_wri_surf( surfdata, clfiletype, padd, pext )
       !!-----------------------------------------------------------------------
       !!
@@ -315,16 +306,20 @@
 
       !! * Arguments
-      TYPE(obs_surf), INTENT(INOUT) :: surfdata         ! Full set of surface data
-      TYPE(obswriinfo), OPTIONAL :: padd               ! Additional info for each variable
-      TYPE(obswriinfo), OPTIONAL :: pext               ! Extra info
+      TYPE(obs_surf), INTENT(INOUT) :: surfdata      ! Full set of surface data
+      CHARACTER(LEN=25), INTENT(IN) :: clfiletype    ! Base name for file name
+      TYPE(obswriinfo), OPTIONAL    :: padd          ! Additional info for each variable
+      TYPE(obswriinfo), OPTIONAL    :: pext          ! Extra info
 
       !! * Local declarations
       TYPE(obfbdata) :: fbdata
       CHARACTER(LEN=40) :: clfname         ! netCDF filename
-      CHARACTER(LEN=10) :: clfiletype
+      CHARACTER(LEN=ilenlong) :: cllongname  ! Long name of variable
+      CHARACTER(LEN=ilenunit) :: clunits     ! Units of variable
+      CHARACTER(LEN=ilengrid) :: clgrid      ! Grid of variable
       CHARACTER(LEN=12), PARAMETER :: cpname = 'obs_wri_surf'
       INTEGER :: jo
       INTEGER :: ja
       INTEGER :: je
+      INTEGER :: jvar
       INTEGER :: iadd
       INTEGER :: iext
@@ -344,118 +339,37 @@
       CALL init_obfbdata( fbdata )
 
-      SELECT CASE ( TRIM(surfdata%cvars(1)) )
-      CASE('SLA')
-
-         CALL alloc_obfbdata( fbdata, 1, surfdata%nsurf, 1, &
-            &                 2 + iadd, 1 + iext, .TRUE. )
-
-         clfiletype = 'slafb'
-         fbdata%cname(1)      = surfdata%cvars(1)
-         fbdata%coblong(1)    = 'Sea level anomaly'
-         fbdata%cobunit(1)    = 'Metres'
-         fbdata%cextname(1)   = 'MDT'
-         fbdata%cextlong(1)   = 'Mean dynamic topography'
-         fbdata%cextunit(1)   = 'Metres'
-         DO je = 1, iext
-            fbdata%cextname(je) = pext%cdname(je)
-            fbdata%cextlong(je) = pext%cdlong(je,1)
-            fbdata%cextunit(je) = pext%cdunit(je,1)
-         END DO
-         fbdata%caddlong(1,1) = 'Model interpolated SSH - MDT'
-         fbdata%caddunit(1,1) = 'Metres' 
-         fbdata%caddname(2)   = 'SSH'
-         fbdata%caddlong(2,1) = 'Model Sea surface height'
-         fbdata%caddunit(2,1) = 'Metres'
-         fbdata%cgrid(1)      = 'T'
-         DO ja = 1, iadd
-            fbdata%caddname(2+ja) = padd%cdname(ja)
-            fbdata%caddlong(2+ja,1) = padd%cdlong(ja,1)
-            fbdata%caddunit(2+ja,1) = padd%cdunit(ja,1)
-         END DO
-
-      CASE('SST')
-
-         CALL alloc_obfbdata( fbdata, 1, surfdata%nsurf, 1, &
+      CALL alloc_obfbdata( fbdata, surfdata%nvar, surfdata%nsurf, 1, &
             &                 1 + iadd, iext, .TRUE. )
-
-         clfiletype = 'sstfb'
-         fbdata%cname(1)      = surfdata%cvars(1)
-         fbdata%coblong(1)    = 'Sea surface temperature'
-         fbdata%cobunit(1)    = 'Degree centigrade'
-         DO je = 1, iext
-            fbdata%cextname(je) = pext%cdname(je)
-            fbdata%cextlong(je) = pext%cdlong(je,1)
-            fbdata%cextunit(je) = pext%cdunit(je,1)
-         END DO
-         fbdata%caddlong(1,1) = 'Model interpolated SST'
-         fbdata%caddunit(1,1) = 'Degree centigrade'
-         fbdata%cgrid(1)      = 'T'
-         DO ja = 1, iadd
-            fbdata%caddname(1+ja) = padd%cdname(ja)
-            fbdata%caddlong(1+ja,1) = padd%cdlong(ja,1)
-            fbdata%caddunit(1+ja,1) = padd%cdunit(ja,1)
-         END DO
-
-      CASE('ICECONC')
-
-         CALL alloc_obfbdata( fbdata, 1, surfdata%nsurf, 1, &
-            &                 1 + iadd, iext, .TRUE. )
-
-         clfiletype = 'sicfb'
-         fbdata%cname(1)      = surfdata%cvars(1)
-         fbdata%coblong(1)    = 'Sea ice'
-         fbdata%cobunit(1)    = 'Fraction'
-         DO je = 1, iext
-            fbdata%cextname(je) = pext%cdname(je)
-            fbdata%cextlong(je) = pext%cdlong(je,1)
-            fbdata%cextunit(je) = pext%cdunit(je,1)
-         END DO
-         fbdata%caddlong(1,1) = 'Model interpolated ICE'
-         fbdata%caddunit(1,1) = 'Fraction'
-         fbdata%cgrid(1)      = 'T'
-         DO ja = 1, iadd
-            fbdata%caddname(1+ja) = padd%cdname(ja)
-            fbdata%caddlong(1+ja,1) = padd%cdlong(ja,1)
-            fbdata%caddunit(1+ja,1) = padd%cdunit(ja,1)
-         END DO
-
-      CASE('SSS')
-
-         CALL alloc_obfbdata( fbdata, 1, surfdata%nsurf, 1, &
-            &                 1 + iadd, iext, .TRUE. )
-
-         clfiletype = 'sssfb'
-         fbdata%cname(1)      = surfdata%cvars(1)
-         fbdata%coblong(1)    = 'Sea surface salinity'
-         fbdata%cobunit(1)    = 'psu'
-         DO je = 1, iext
-            fbdata%cextname(je) = pext%cdname(je)
-            fbdata%cextlong(je) = pext%cdlong(je,1)
-            fbdata%cextunit(je) = pext%cdunit(je,1)
-         END DO
-         fbdata%caddlong(1,1) = 'Model interpolated SSS'
-         fbdata%caddunit(1,1) = 'psu'
-         fbdata%cgrid(1)      = 'T'
-         DO ja = 1, iadd
-            fbdata%caddname(1+ja) = padd%cdname(ja)
-            fbdata%caddlong(1+ja,1) = padd%cdlong(ja,1)
-            fbdata%caddunit(1+ja,1) = padd%cdunit(ja,1)
-         END DO
-
-      CASE DEFAULT
-
-         CALL ctl_stop( 'Unknown observation type '//TRIM(surfdata%cvars(1))//' in obs_wri_surf' )
-
-      END SELECT
-
       fbdata%caddname(1)   = 'Hx'
-
-      WRITE(clfname, FMT="(A,'_fdbk_',I4.4,'.nc')") TRIM(clfiletype), nproc
+      DO jvar = 1, surfdata%nvar
+         fbdata%cname(jvar)      = surfdata%cvars(jvar)
+         fbdata%coblong(jvar)    = surfdata%clong(jvar)
+         fbdata%cobunit(jvar)    = surfdata%cunit(jvar)
+         fbdata%cgrid(jvar)      = surfdata%cgrid(jvar)
+         fbdata%caddlong(1,jvar) = 'Model interpolated ' // TRIM(surfdata%clong(jvar))
+         fbdata%caddunit(1,jvar) = surfdata%cunit(jvar)
+         IF (iadd > 0) THEN
+            DO ja = 1, iadd
+               fbdata%caddname(1+ja) = padd%cdname(ja)
+               fbdata%caddlong(1+ja,jvar) = padd%cdlong(ja,jvar)
+               fbdata%caddunit(1+ja,jvar) = padd%cdunit(ja,jvar)
+            END DO
+         ENDIF
+         IF (iext > 0) THEN
+            DO je = 1, iext
+               fbdata%cextname(je) = pext%cdname(je)
+               fbdata%cextlong(je) = pext%cdlong(je,1)
+               fbdata%cextunit(je) = pext%cdunit(je,1)
+            END DO
+         ENDIF
+      END DO
+
+      WRITE(clfname, FMT="(A,'fb_fdbk_',I4.4,'.nc')") TRIM(clfiletype), nproc
 
       IF(lwp) THEN
          WRITE(numout,*)
-         WRITE(numout,*)'obs_wri_surf :'
-         WRITE(numout,*)'~~~~~~~~~~~~~'
-         WRITE(numout,*)'Writing '//TRIM(surfdata%cvars(1))//' feedback file : ',TRIM(clfname)
+         WRITE(numout,*) 'obs_wri_surf :'
+         WRITE(numout,*) '~~~~~~~~~~~~~'
+         WRITE(numout,*) 'Writing '//TRIM(surfdata%cvars(1))//' feedback file : ', TRIM(clfname)
       ENDIF
 
@@ -484,11 +398,13 @@
          fbdata%cdwmo(jo)     = surfdata%cwmo(jo)
          fbdata%kindex(jo)    = surfdata%nsfil(jo)
-         IF (ln_grid_global) THEN
-            fbdata%iobsi(jo,1) = surfdata%mi(jo)
-            fbdata%iobsj(jo,1) = surfdata%mj(jo)
-         ELSE
-            fbdata%iobsi(jo,1) = mig(surfdata%mi(jo))
-            fbdata%iobsj(jo,1) = mjg(surfdata%mj(jo))
-         ENDIF
+         DO jvar = 1, surfdata%nvar
+            IF (ln_grid_global) THEN
+               fbdata%iobsi(jo,jvar) = surfdata%mi(jo,jvar)
+               fbdata%iobsj(jo,jvar) = surfdata%mj(jo,jvar)
+            ELSE
+               fbdata%iobsi(jo,jvar) = mig(surfdata%mi(jo,jvar))
+               fbdata%iobsj(jo,jvar) = mjg(surfdata%mj(jo,jvar))
+            ENDIF
+         END DO
          CALL greg2jul( 0, &
             &           surfdata%nmin(jo), &
@@ -498,33 +414,37 @@
             &           surfdata%nyea(jo), &
             &           fbdata%ptim(jo),   &
-            &           krefdate = 19500101 )
-         fbdata%padd(1,jo,1,1) = surfdata%rmod(jo,1)
-         IF ( TRIM(surfdata%cvars(1)) == 'SLA' ) fbdata%padd(1,jo,2,1) = surfdata%rext(jo,1)
-         fbdata%pob(1,jo,1)    = surfdata%robs(jo,1) 
+            &           krefdate = 19500101 ) 
          fbdata%pdep(1,jo)     = 0.0
          fbdata%idqc(1,jo)     = 0
          fbdata%idqcf(:,1,jo)  = 0
-         IF ( surfdata%nqc(jo) > 255 ) THEN
-            fbdata%ivqc(jo,1)       = 4
-            fbdata%ivlqc(1,jo,1)    = 4
-            fbdata%ivlqcf(1,1,jo,1) = 0
+         DO jvar = 1, surfdata%nvar
+            fbdata%padd(1,jo,1,jvar) = surfdata%rmod(jo,jvar)
+            fbdata%pob(1,jo,jvar)    = surfdata%robs(jo,jvar)
+            IF ( surfdata%nqc(jo) > 255 ) THEN
+               fbdata%ivqc(jo,jvar)       = 4
+               fbdata%ivlqc(1,jo,jvar)    = 4
+               fbdata%ivlqcf(1,1,jo,jvar) = 0
 !$AGRIF_DO_NOT_TREAT
-            fbdata%ivlqcf(2,1,jo,1) = IAND(surfdata%nqc(jo),b'0000000011111111')
+               fbdata%ivlqcf(2,1,jo,jvar) = IAND(surfdata%nqc(jo),b'0000000011111111')
 !$AGRIF_END_DO_NOT_TREAT
-         ELSE
-            fbdata%ivqc(jo,1)       = surfdata%nqc(jo)
-            fbdata%ivlqc(1,jo,1)    = surfdata%nqc(jo)
-            fbdata%ivlqcf(:,1,jo,1) = 0
-         ENDIF
-         fbdata%iobsk(1,jo,1)  = 0
-         IF ( TRIM(surfdata%cvars(1)) == 'SLA' ) fbdata%pext(1,jo,1) = surfdata%rext(jo,2)
-         DO ja = 1, iadd
-            fbdata%padd(1,jo,2+ja,1) = &
-               & surfdata%rext(jo,padd%ipoint(ja))
+            ELSE
+               fbdata%ivqc(jo,jvar)       = surfdata%nqc(jo)
+               fbdata%ivlqc(1,jo,jvar)    = surfdata%nqc(jo)
+               fbdata%ivlqcf(:,1,jo,jvar) = 0
+            ENDIF
+            fbdata%iobsk(1,jo,jvar)  = 0
+            IF (iadd > 0) THEN
+               DO ja = 1, iadd
+                  fbdata%padd(1,jo,1+ja,jvar) = &
+                     & surfdata%radd(jo,padd%ipoint(ja),jvar)
+               END DO
+            ENDIF
          END DO
-         DO je = 1, iext
-            fbdata%pext(1,jo,1+je) = &
-               & surfdata%rext(jo,pext%ipoint(je))
-         END DO
+         IF (iext > 0) THEN
+            DO je = 1, iext
+               fbdata%pext(1,jo,je) = &
+                  & surfdata%rext(jo,pext%ipoint(je))
+            END DO
+         ENDIF
       END DO
 
@@ -574,7 +494,7 @@
 
       DO jvar = 1, fbdata%nvar
-         zsumx=0.0_wp
-         zsumx2=0.0_wp
-         inumgoodobs=0
+         zsumx = 0.0_wp
+         zsumx2 = 0.0_wp
+         inumgoodobs = 0
          DO jo = 1, fbdata%nobs
             DO jk = 1, fbdata%nlev
@@ -583,8 +503,8 @@
                   & ( fbdata%padd(jk,jo,1,jvar) < 9999.0 ) ) THEN
 
-                  zomb=fbdata%pob(jk, jo, jvar)-fbdata%padd(jk, jo, 1, jvar)
-                  zsumx=zsumx+zomb
-                  zsumx2=zsumx2+zomb**2
-                  inumgoodobs=inumgoodobs+1
+                  zomb = fbdata%pob(jk, jo, jvar)-fbdata%padd(jk, jo, 1, jvar)
+                  zsumx = zsumx + zomb
+                  zsumx2 = zsumx2 + zomb**2
+                  inumgoodobs = inumgoodobs + 1
                ENDIF
             ENDDO
@@ -596,7 +516,9 @@
 
          IF (lwp) THEN
-            WRITE(numout,*) 'Type: ',fbdata%cname(jvar),'  Total number of good observations: ',inumgoodobsmpp 
-            WRITE(numout,*) 'Overall mean obs minus model of the good observations: ',zsumx/inumgoodobsmpp
-            WRITE(numout,*) 'Overall RMS obs minus model of the good observations: ',sqrt( zsumx2/inumgoodobsmpp )
+            WRITE(numout,*) 'Type: ', fbdata%cname(jvar), '  Total number of good observations: ', inumgoodobsmpp
+            IF ( inumgoodobsmpp > 0 ) THEN
+               WRITE(numout,*) 'Overall mean obs minus model of the good observations: ', zsumx/inumgoodobsmpp
+               WRITE(numout,*) 'Overall RMS obs minus model of the good observations: ', sqrt( zsumx2/inumgoodobsmpp )
+            ENDIF
             WRITE(numout,*) ''
          ENDIF
Index: NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/TRA/tradmp.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/TRA/tradmp.F90	(revision 15731)
+++ NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/TRA/tradmp.F90	(revision 15799)
@@ -50,4 +50,6 @@
    !
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   resto    !: restoring coeff. on T and S (s-1)
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   tclim    !: temperature climatology on each time step(Celcius)
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   sclim    !: salinity climatology on each time step (psu)
 
    !! * Substitutions
@@ -64,5 +66,7 @@
       !!                ***  FUNCTION tra_dmp_alloc  ***
       !!----------------------------------------------------------------------
-      ALLOCATE( resto(jpi,jpj,jpk), STAT= tra_dmp_alloc )
+      ALLOCATE( resto(jpi,jpj,jpk), &
+         &      tclim(jpi,jpj,jpk), &
+         &      sclim(jpi,jpj,jpk), STAT= tra_dmp_alloc )
       !
       CALL mpp_sum ( 'tradmp', tra_dmp_alloc )
@@ -106,4 +110,7 @@
       CALL dta_tsd( kt, zts_dta )            ! read and interpolates T-S data at kt
       !
+      tclim(:,:,:) = zts_dta(:,:,:,jp_tem)
+      sclim(:,:,:) = zts_dta(:,:,:,jp_sal)
+      !
       SELECT CASE ( nn_zdmp )     !==  type of damping  ==!
       !
